#include "enter"

#ifndef (GAUGES_INC)
  #declare GAUGES_INC = 1 ;

  #include "metrics.inc"
  #ifndef (HighQuality)
    #declare HighQuality = on ;
  #end
  #include "machtext.inc"
  
  #if (!included)
    sky_sphere {
      pigment {
	gradient y
	color_map {
	  [ 0.0 rgb 0.5 ]
	  [ 1.0 rgb 0.0 ]
	}
      }
    }
  #end
  
  #declare Seed = seed (2174);

  // Texture Macros //////////////////////////////////////////////////
  
  #macro MetalTexture()
    texture { TMetal }
    texture { 
      Scarring 
      scale 1*cm
      translate <rand (Seed)*m, rand (Seed)*m, rand (Seed)*m>
    }
    texture { 
      Chipping2
      scale 1*mm
      translate <rand (Seed)*m, rand (Seed)*m, rand (Seed)*m>
    }
    texture { 
      Rusting2
      scale 1*cm
      translate <rand (Seed)*m, rand (Seed)*m, rand (Seed)*m>
    }
    texture {
      Rusting
      scale 5*mm
      translate <rand (Seed)*m, rand (Seed)*m, rand (Seed)*m>
    }
    texture {
      Dirt
      scale 1*cm
      translate <rand (Seed)*m, rand (Seed)*m, rand (Seed)*m>
    }
  #end

  #macro ChromeTexture()
    texture { TChrome }
    texture { 
      Scarring 
      scale 1*cm
      translate <rand (Seed)*m, rand (Seed)*m, rand (Seed)*m>
    }
    texture { 
      Chipping2
      scale 1*mm
      translate <rand (Seed)*m, rand (Seed)*m, rand (Seed)*m>
    }
    texture {
      Rusting
      translate <rand (Seed)*m, rand (Seed)*m, rand (Seed)*m>
      scale 1*mm
    }
    texture {
      Rusting
      translate <rand (Seed)*m, rand (Seed)*m, rand (Seed)*m>
      scale 2*mm
    }
    texture {
      Rusting2
      translate <rand (Seed)*m, rand (Seed)*m, rand (Seed)*m>
      scale 1*mm
    }
    texture {
      Rusting2
      translate <rand (Seed)*m, rand (Seed)*m, rand (Seed)*m>
      scale 2*mm
    }
    texture {
      Rusting2
      translate <rand (Seed)*m, rand (Seed)*m, rand (Seed)*m>
      scale 4*mm
    }
    texture {
      Rusting2
      translate <rand (Seed)*m, rand (Seed)*m, rand (Seed)*m>
      scale 8*mm
    }
    texture {
      Dirt
      translate <rand (Seed)*m, rand (Seed)*m, rand (Seed)*m>
      scale 1*cm
    }
  #end
  
  #macro WhitePlasticTexture()
    texture { TWhitePlastic }
    texture {
      Dirt
      scale 1*cm
      translate <rand (Seed)*m, rand (Seed)*m, rand (Seed)*m>
    }
  #end
  
  #macro BlackPlasticTexture()
    texture { TBlackPlastic }
    texture {
      Dirt
      scale 1*cm
      translate <rand (Seed)*m, rand (Seed)*m, rand (Seed)*m>
    }
  #end
  
  #macro ClearPlasticTexture()
    texture { TClearPlastic }
    texture {
      Dirt
      scale 1*cm
      translate <rand (Seed)*m, rand (Seed)*m, rand (Seed)*m>
    }
  #end

  #macro CylPigment (C)
    cylindrical
    color_map {
      [ 0.20 color rgb 0.0 transmit 1 ]
      [ 0.20 color rgb 0.0 ]
      [ 0.21 color rgb 0.0 ]
      [ 0.21 color rgbt C ]
      [ 0.29 color rgbt C ]
      [ 0.30 color rgb 0.0 ]
      [ 0.30 color rgb 0.0 transmit 1 ]
    }
  #end
  
  // Gauge Macros ////////////////////////////////////////////////////
  
  #declare BasicPanel = union {
    box { -<6.6*cm, 5.7*cm, 6*mm>, <6.6*cm, 5.7*cm, 6*mm> }
    box { -<5.7*cm, 6.6*cm, 6*mm>, <5.7*cm, 6.6*cm, 2*mm> }
    cylinder { <5.7*cm, 5.7*cm, -6*mm>, <5.7*cm, 5.7*cm, 6*mm>, 9*mm }
    cylinder { <-5.7*cm, 5.7*cm, -6*mm>, <-5.7*cm, 5.7*cm, 6*mm>, 9*mm }
    cylinder { <5.7*cm, -5.7*cm, -6*mm>, <5.7*cm, -5.7*cm, 6*mm>, 9*mm }
    cylinder { <-5.7*cm, -5.7*cm, -6*mm>, <-5.7*cm, -5.7*cm, 6*mm>, 9*mm }
    
    cylinder { <-6.6*cm, -5.7*cm, 0>, <-6.6*cm, 5.7*cm, 0>, 6*mm }
    cylinder { <-5.7*cm, 6.6*cm, 0>, <5.7*cm, 6.6*cm, 0>, 6*mm }
    cylinder { <6.6*cm, 5.7*cm, 0>, <6.6*cm, -5.7*cm, 0>, 6*mm }
    cylinder { <5.7*cm, -6.6*cm, 0>, <-5.7*cm, -6.6*cm, 0>, 6*mm }
    torus { 9*mm, 6*mm rotate 90*x translate <-5.7*cm, -5.7*cm, 0> }
    torus { 9*mm, 6*mm rotate 90*x translate <5.7*cm, -5.7*cm, 0> }
    torus { 9*mm, 6*mm rotate 90*x translate <-5.7*cm, 5.7*cm, 0> }
    torus { 9*mm, 6*mm rotate 90*x translate <5.7*cm, 5.7*cm, 0> }

    sphere { 0, 9*mm scale <1, 1, 0.5> translate <-5.7*cm, -5.7*cm, -6*mm > }
    sphere { 0, 9*mm scale <1, 1, 0.5> translate <5.7*cm, -5.7*cm, -6*mm > }
    sphere { 0, 9*mm scale <1, 1, 0.5> translate <-5.7*cm, 5.7*cm, -6*mm > }
    sphere { 0, 9*mm scale <1, 1, 0.5> translate <5.7*cm, 5.7*cm, -6*mm > }
  }
  
  #macro Gauge1()
    union {
      difference {
	object { BasicPanel }
	cylinder { 
	  0, -9*mm*z, 6*cm
	  WhitePlasticTexture()
	  texture {
	    pigment {
	      radial
	      pigment_map {
		#local C1 = 0.2+0.1*rand (Seed);
		#local C2 = 0.4+0.1*rand (Seed);
		#local C3 = 0.6+0.1*rand (Seed);
		[ 0.005 CylPigment (0.0) ]
		[ 0.005 CylPigment (<0.0, 0.0, 0.0, 1.0>) ]
		[ C1    CylPigment (<0.0, 0.0, 0.0, 1.0>) ]
		[ C1    CylPigment (<0.0, 1.0, 0.0, 0.0>) ]
		[ C2    CylPigment (<0.0, 1.0, 0.0, 0.0>) ]
		[ C2    CylPigment (<1.0, 1.0, 0.0, 0.0>) ]
		[ C3    CylPigment (<1.0, 1.0, 0.0, 0.0>) ]
		[ C3    CylPigment (<1.0, 0.0, 0.0, 0.0>) ]
		[ 0.740 CylPigment (<1.0, 0.0, 0.0, 0.0>) ]
		[ 0.740 CylPigment (0.0) ]
		[ 0.745 CylPigment (0.0) ]
		[ 0.745 color rgb 0.0 transmit 1.0 ]
	      }
	    }
	    scale 6*cm
	    rotate -90*x
	    rotate -135*z
	  }
	}
	MetalTexture()
      }
      merge {
	cylinder { 3*mm*z, -9*mm*z, 6*cm }
	cylinder { 3*mm*z, -12*mm*z, 5.7*cm }
	torus { 5.7*cm, 3*mm rotate 90*x translate -9*mm*z }
	ClearPlasticTexture()
	interior { ior 1.3 }
      }
      union {
	cylinder { 0, -4.5*mm*z, 9*mm }
	cylinder { -3*mm*z, -3*mm*z+4.5*cm*y, 1.5*mm }
	sphere { -3*mm*z+4.5*cm*y, 1.5*mm }
	pigment { color rgb 0.0 }
	rotate (-120+240*rand(Seed))*z
      }
    }
  #end

  //--------------------------------------------------------
  
  #macro MakeLight()
    cylinder { 0, -4*mm*z, 5*mm }
    sphere { -4*mm*z, 5*mm }
    texture {
      pigment {
	#local C = rand (Seed);
	#if (C<1/3)
	  color rgb <1.0, 0.0, 0.0>
	#else 
	  #if (C<2/3)
	    color rgb <1.0, 1.0, 0.0>
	  #else 
	    color rgb <0.0, 1.0, 0.0>
	  #end
	#end
      }
      finish {
	specular 0.5
	roughness 0.05
	#if (rand (Seed)<0.5)
	  ambient 1
	#end
      }
    }
    texture {
      Scarring
      scale 5*mm
      translate <rand (Seed)*m, rand (Seed)*m, rand (Seed)*m>
    }
    texture {
      Scarring
      scale 1*cm
      translate <rand (Seed)*m, rand (Seed)*m, rand (Seed)*m>
    }
    texture {
      Dirt
      scale 5*mm
      translate <rand (Seed)*m, rand (Seed)*m, rand (Seed)*m>
    }
    texture {
      Dirt
      scale 1*cm
      translate <rand (Seed)*m, rand (Seed)*m, rand (Seed)*m>
    }
  #end
  
  #macro Gauge2()
    union {
      union {
	object { BasicPanel }
	#local i = -4*cm ;
	#while (i <= 4*cm)
	  #local j = -4*cm ;
	  #while (j <= 4*cm)
	    torus { 5*mm, 1*mm rotate 90*x translate <i, j, -6*mm> }
	    #local j = j + 2*cm ;
	  #end
	  #local i = i + 2*cm ;
	#end
	MetalTexture()
      }
      #local i = -4*cm ;
      #while (i <= 4*cm)
	#local j = -4*cm ;
	#while (j <= 4*cm)
	  union { MakeLight() translate <i, j, -6*mm> }
	  #local j = j + 2*cm ;
	#end
	#local i = i + 2*cm ;
      #end
    }
  #end
  
  //--------------------------------------------------------
  
  #macro Gauge3()
    #local Switch = union {
      sphere { 0, 2*mm }
      prism {
	linear_sweep
	cubic_spline
	-2.5*mm, 2.5*mm,
	12, 
	<0, -6*mm>, <0, -3*mm>, <-3*mm, 0>, <-3.3*mm, 6*mm>, <-6*mm, 10.5*mm>, <-6*mm, 15*mm>, 
	<6*mm, 15*mm>, <6*mm, 10.5*mm>, <3.3*mm, 6*mm>, <3*mm, 0>, <0, -3*mm>, <0, -6*mm>
	scale -1
	translate -4.5*mm*z
      }
    }
    union {
      union {
	object { BasicPanel }
	#local i = -3.6*cm ;
	#while (i < 6*cm)
	  #local j = -3.6*cm ;
	  #while (j < 6*cm)
	    torus { 6*mm, 1.5*mm rotate 90*x translate -6*mm*z+i*x+j*y }
	    #local j = j + 3.6*cm ;
	  #end
	  #local i = i + 3.6*cm ;
	#end
	MetalTexture()
      }
      #local i = -3.6*cm ;
      #while (i < 6*cm)
	#local j = -3.6*cm ;
	#while (j < 6*cm)
	  object {
	    Switch
	    #if (rand (Seed) < 0.5)
	      rotate -45*x
	    #else
	      rotate 45*x
	    #end
	    translate -6*mm*z+i*x+j*y
	    texture { TChrome }
	    texture { Dirt scale 1*cm }
	  }
	  #local j = j + 3.6*cm ;
	#end
	#local i = i + 3.6*cm ;
      #end
    }
  #end
  
  //--------------------------------------------------------
  
  #macro Gauge4()
    #local Switch = union {
      union {
	box { <-3*cm, -7.5*mm, 0>, <-24*mm, 7.5*mm, -6*cm> }
	box { <3*cm, -7.5*mm, 0>, <24*mm, 7.5*mm, -6*cm> }
	box { <-3*cm, -7.5*mm, -5.7*cm>, <3*cm, 7.5*mm, -6.3*cm> }
	cylinder { <-3.9*cm, 0, -9*mm>, <3.9*cm, 0, -9*mm>, 7.5*mm }
	cylinder { <0, 0, -6*cm>, <0, 0, -16.8*cm>, 7.5*mm }
	sphere { <0, 0, -16.8*cm>, 7.5*mm }
	ChromeTexture()
      }
      cone {
	-9*cm*z, 1.05*cm, -16.5*cm*z, 1.5*cm
	BlackPlasticTexture()
	texture {
	  Scarring
	  translate <rand (Seed)*m, rand (Seed)*m, rand (Seed)*m>
	  scale 5*mm
	}
	texture {
	  Scarring
	  translate <rand (Seed)*m, rand (Seed)*m, rand (Seed)*m>
	  scale 1*cm
	}
      }
      translate 9*mm*z
    }
    union {
      union {
	object { BasicPanel }
	box { <-3.6*cm, -12*mm, 0>, <-3.15*cm, 12*mm, -4.2*cm> }
	box { <3.6*cm, -12*mm, 0>, <3.15*cm, 12*mm, -4.2*cm> }
	MetalTexture()
      }

      #local Plot = union {
	difference {
	  cylinder { 0, -3*cm*z, 6*mm }
	  box { <-3.3*mm, -15*mm, -2.1*cm>, <3.3*mm, 15*mm, -3.3*cm> }
	  texture { TChrome }
	  texture { Rusting2 scale 1*mm }
      	  texture { Rusting2 scale 2*mm translate 1*m }
	}
	sphere {
	  0, 7.2*mm
	  scale <1, 1, 2>
	  translate -6*mm*z
	  WhitePlasticTexture()
	}
      }
      object { Plot translate <-2.7*cm, 3*cm, 0> }
      object { Plot translate <2.7*cm, 3*cm, 0> }
      object { Plot translate <-2.7*cm, -3*cm, 0> }
      object { Plot translate <2.7*cm, -3*cm, 0> }

      object {
	Switch
	#if (rand (Seed) < 0.5)
	  rotate 80*x
	#else
	  rotate -80*x
	#end
	translate -3*cm*z
      }
    }
  #end

  //--------------------------------------------------------
  
  #macro Gauge5()
    union {
      object {
	BasicPanel
	MetalTexture()
      }
      blob {
	threshold 1
	sphere { 0, 4.908*cm, 10 scale <1, 1, 0.25> }
	cylinder { <0, -3*cm, -3*cm>, <0, 2.7*cm, -3*cm>, 6*cm, 2 scale <0.2, 1, 0.5> }
	cylinder { 0, <0, 0, -9*cm>, 2.25*cm, 5 scale <1, 1, 1/3> }
	sphere { <0, -6*cm, -3*mm>, 2.1*cm, -2.7 scale <5, 1, 5> }
	BlackPlasticTexture()
	translate -9*mm*z
	rotate 360*rand (Seed)*z
      }
    }
  #end
  
  //--------------------------------------------------------
  
  #macro Gauge6()
    #local Graduat = pigment {
      radial 
      pigment_map {
	#local C = 0.75+0.1*rand (Seed) ;
	[ C radial 
	  color_map {
	    [ 0.1 color rgb 0 ]
	    [ 0.1 color rgb 0 transmit 1 ]
	  }
	  frequency 45+10*rand (Seed)
	]
	[ C color rgb <1, 0, 0> ]
      }
    }
    #local Hole = difference {
      cylinder { 0, -9*mm*z, 6*cm }
      cylinder { 3*mm*z, -12*mm*z, 4.5*cm }
      plane { x, 0 rotate 45*z }
      plane { -x, 0 rotate -45*z }
      WhitePlasticTexture()
      texture {
	pigment {
	  cylindrical
	  pigment_map {
	    [ 0.05 color rgb 0.0 transmit 1.0 ]
	    [ 0.05 Graduat ]
	    [ 0.15 Graduat ]
	    [ 0.15 color rgb 0.0 transmit 1.0 ]
	  }
	  scale 6*cm
	  rotate -90*x
	}
      }
    }
    #local Cover = merge {
      difference {
	cylinder { 3*mm*z, -9*mm*z, 6*cm }
	cylinder { 6*mm*z, -12*mm*z, 4.5*cm }
	plane { x, 0 rotate 45*z }
	plane { -x, 0 rotate -45*z }
      }
      difference {
	merge {
	  difference {
	    cylinder { 3*mm*z, -12*mm*z, 5.7*cm }
	    cylinder { 6*mm*z, -15*mm*z, 4.8*cm }
	  }
	  torus { 5.7*cm, 3*mm rotate 90*x translate -9*mm*z }
	  torus { 4.8*cm, 3*mm rotate 90*x translate -9*mm*z }
	}
	plane { x, 1*mm rotate 45*z }
	plane { -x, 1*mm rotate -45*z }
      }
      merge {
	cylinder { <0, 4.8*cm, -9*mm>, <0, 5.7*cm, -9*mm>, 3*mm }
	sphere { <0, 4.8*cm, -9*mm>, 3*mm }
	sphere { <0, 5.7*cm, -9*mm>, 3*mm }
	translate 3*mm*x
	rotate 45*z
      }
      merge {
	cylinder { <0, 4.8*cm, -9*mm>, <0, 5.7*cm, -9*mm>, 3*mm }
	sphere { <0, 4.8*cm, -9*mm>, 3*mm }
	sphere { <0, 5.7*cm, -9*mm>, 3*mm }
	translate -3*mm*x
	rotate -45*z
      }
      ClearPlasticTexture()
      interior { ior 1.3 }
    }
    union {
      difference {
	object { BasicPanel }
	object { Hole translate -15*mm*y }
	object { Hole translate -6*cm*y }
	MetalTexture()
      }
      object { Cover translate -15*mm*y }
      object { Cover translate -6*cm*y }
      union {
	cylinder { 4.2*cm*y, 5.25*cm*y, 1.5*mm }
	sphere { 5.25*cm*y, 1.5*mm }
	pigment { color rgb 0.0 }
	rotate (-40+80*rand (Seed))*z
	translate -3*mm*z-15*mm*y
      }
      union {
	cylinder { 4.2*cm*y, 5.25*cm*y, 1.5*mm }
	sphere { 5.25*cm*y, 1.5*mm }
	pigment { color rgb 0.0 }
	rotate (-40+80*rand (Seed))*z
	translate -3*mm*z-6*cm*y
      }
    }
  #end
  
  //--------------------------------------------------------
  
  #macro GaugePanel (W, H)
    union {
      box { <-W*7.5*cm-6*cm, -H*7.5*cm, 9*cm>, <W*7.5*cm+6*cm, H*7.5*cm, 0> }
      box { <-W*7.5*cm, -H*7.5*cm-6*cm, 9*cm>, <W*7.5*cm, H*7.5*cm+6*cm, 0> }
      cylinder { <-W*7.5*cm, -H*7.5*cm, 9*cm>, <-W*7.5*cm, -H*7.5*cm, 0>, 6*cm }
      cylinder { <W*7.5*cm, -H*7.5*cm, 9*cm>, <W*7.5*cm, -H*7.5*cm, 0>, 6*cm }
      cylinder { <-W*7.5*cm, H*7.5*cm, 9*cm>, <-W*7.5*cm, H*7.5*cm, 0>, 6*cm }
      cylinder { <W*7.5*cm, H*7.5*cm, 9*cm>, <W*7.5*cm, H*7.5*cm, 0>, 6*cm }
      #local i = 0 ;
      #while (i<W)
	#local j = 0 ;
	#while (j<H)
	  object {
	    #local Which = rand (Seed);
	    #switch (Which)
	      #range (0, 0.25)
		Gauge1()
	      #break
	      #range (0.25, 0.5)
		Gauge6()
	      #break
	      #range (0.5, 0.625)
		Gauge2()
	      #break
	      #range (0.625, 0.75)
		Gauge3()
	      #break
	      #range (0.75, 0.875)
		Gauge4()
	      #break
	    #else
	      Gauge5()
	    #end
	    translate ((i-W/2)*15*cm+7.5*cm)*x+((j-H/2)*15*cm+7.5*cm)*y
	  }
	  #local j = j + 1 ;
	#end
	#local i = i + 1 ;
      #end
      ChromeTexture()
    }
  #end
  
  //--------------------------------------------------------
  
  #if (!included)
    global_settings {
      assumed_gamma 1
      max_trace_level 10
    }
    camera {
      location -50*cm*z
      look_at  0
      angle 40
    }
    light_source {
      <1000, 1000, -1000>*m
      color rgb 1
    }
    light_source {
      <-1000, 1000, -1000>*m
      color rgb 1/4
    }
    light_source {
      <0, 1000, 1000>*m
      color rgb 1/4
    }
    /*object {
      Gauge1()
      translate -5*cm*x+2.5*cm*y
    }
    object {
      Gauge2()
      translate 2.5*cm*y
    }
    object {
      Gauge3()
      translate 5*cm*x+2.5*cm*y
    }
    object {
      Gauge4()
      translate -5*cm*x-2.5*cm*y
    }
    object {
      Gauge5()
      translate -2.5*cm*y
    }
    object {
      Gauge6()
      translate 5*cm*x-2.5*cm*y
    }*/
    object {
      GaugePanel(6, 6)
      translate 150*cm*z
    }
    /*plane {
      y, -1*m
      texture {
	pigment {
	  cylindrical
	  pigment_map {
	    [ 0.1 color rgb 0.5 ]
	    [ 0.4 checker
	      color rgb 0.8
	      color rgb 0.2
	      scale 50*cm/(10*m)
	    ]
	  }
	}
	scale 10*m
	rotate 45*y
      }
    }*/
  #end
#end

#include "leave"
