#include "enter"

#ifndef (MACHTEXT_INC)
  #declare MACHTEXT_INC = 1 ;
  
  #version unofficial MegaPov 0.4 ;
  
  #include "metrics.inc"
  
  #ifndef (HighQuality)
    #declare HighQuality = false ;
  #end
  
  #default {
    finish { ambient 0.0 diffuse 0.2 }
  }

  #declare Scarring = texture {
    pigment {
      bozo
      color_map {
	[0 rgb .175 transmit .75]
	[1 rgb .175 transmit  1]
      }
      scale 2
    }
  }
  texture {
    pigment {
      bozo
      pigment_map {
	[0 bozo color_map {[0 rgb .125 transmit .75][1 rgb .125 transmit 1]}scale .125]
	[.5 rgb .175 transmit 1]
      }
      scale 2
    }
    translate 25
  }

  #declare Rusting = texture {
    pigment {
      bozo
      color_map {
	[0 rgb <1,.5,.4> transmit .75]
	[1 rgb <1,.5,.4> transmit 1]
      }
      scale 2
    }
  }
  texture {
    pigment {
      bozo
      pigment_map {
	[0 bozo color_map {[0 rgb <1,.5,.4> transmit .75][1 rgb <1,.5,.4> transmit 1]}scale .125]
	[.5 rgb .175 transmit 1]
      }
      scale 2
    }
    translate 25
  }

  #declare Rusting2 = texture {
    pigment {
      bozo
      color_map {
	[0 rgb <1,.5,.4> transmit .875]
	[1 rgb <1,.5,.4> transmit 1]
      }
      scale 2
    }
  }
  texture {
    pigment {
      bozo
      pigment_map {
	[0 bozo color_map {[0 rgb <1,.5,.4> transmit .875][1 rgb <1,.5,.4> transmit 1]}scale .125]
	[.5 rgb .175 transmit 1]
      }
      scale 2
    }
    translate 25
  }

  #declare Dirt = texture {
    pigment {
      bozo
      color_map {
	[0 rgb <.6,.5,.4> transmit .75]
	[1 rgb <.6,.5,.4> transmit 1]
      }
      scale 2
    }
  }
  texture {
    pigment {
      bozo
      pigment_map {
	[0 bozo color_map {[0 rgb <.6,.5,.4> transmit .75][1 rgb <.6,.5,.4> transmit 1]}scale .125]
	[.5 rgb <.6,.5,.4> transmit 1]
      }
      scale 2
    }
    translate 5
  }

  #declare Chipping2 = texture {
    normal {
      bozo
      normal_map {
	[.4 bozo normal_map {[.2 bumps scale 1/16/12 bump_size 1/12][.3 bumps scale 1/8 bump_size 0]} turbulence 1/2 scale .125/2]
	[.5 bumps scale 1/8 bump_size 0]
      }
      scale 8
    }
    pigment {
      bozo
      pigment_map {
	[.4 bozo color_map {[.2 rgb 1 transmit .125][.3 rgb 1 transmit 1]} turbulence 1/2 scale .125/2]
	[.5 rgb .175 transmit 1]
      }
      scale 8
    }
  }

  #declare TConcrete = texture {
    pigment {
      average
      pigment_map {
	[ 1.0 gradient y
	  color_map {
	    [ 0.000 color rgb 0.80 ]
	    [ 0.875 color rgb 0.70 ]
	    [ 1.000 color rgb 0.40 ]
	  }
	  turbulence 0.1 ]
	[ 1.0 gradient y
	  color_map {
	    [ 0.000 color rgb 0.80 ]
	    [ 0.875 color rgb 0.70 ]
	    [ 1.000 color rgb 0.40 ]
	  }
	  turbulence 0.1
	  translate 0.5 ]
      }      
    }
    normal { granite 0.05 scale 0.5 }
    //  finish { /*specular 0.1 roughness 4*/ brilliance 0.8 }
    scale 0.4
  } 
  texture {
    pigment {
      gradient y
      pigment_map {
	[ 0.0 color rgb 0 transmit 1 ]
	[ 0.1 color rgb 0 transmit 1 ]
	[ 1.0 bozo
	  color_map {
	    [ 0.0 color rgb 0 transmit 1.00 ]
	    [ 0.6 color rgb 0 transmit 1.00 ]
	    [ 0.9 color rgb 0 transmit 0.75 ]
	    [ 1.0 color rgb 0 transmit 0.50 ]
	  }
	  frequency 1.1
	  scale <0.1, 1.0, 0.1> ]
      }
      turbulence 0.1
    }
    normal { granite 0.05 scale 0.5 }
    finish { /*specular 0.1 roughness 4*/ brilliance 0.8 }
    scale 0.4
  }
  texture {
    pigment {
      gradient y
      pigment_map {
	[ 0.0 color rgb 0 transmit 1 ]
	[ 0.1 color rgb 0 transmit 1 ]
	[ 1.0 bozo
	  color_map {
	    [ 0.0 color rgb 0 transmit 1.00 ]
	    [ 0.6 color rgb 0 transmit 1.00 ]
	    [ 0.9 color rgb 0 transmit 0.75 ]
	    [ 1.0 color rgb 0 transmit 0.50 ]
	  }
	  frequency 1.1
	  scale <0.1, 1.0, 0.1> ]
      } 
      turbulence 0.1
      translate 0.5
    }
    normal { granite 0.05 scale 0.5 }
    finish { /*specular 0.1 roughness 4*/ brilliance 0.8 }
    scale 0.4
  } // end TConcrete

  #declare TMetal = texture {
    pigment { color rgb <0.39, 0.41, 0.43> }
    finish {
      brilliance 3
      metallic
      specular 0.70
      roughness 1/60
      reflection 0.25
      reflection_blur 0.02
      #if (HighQuality)
	reflection_samples 20
      #else
	reflection_samples 1
      #end
    }
  }

  #declare TChrome = texture {
    pigment { rgb <0.658824, 0.658824, 0.658824> }
    finish {
      reflection 0.15
      reflection_blur 0.005
      #if (HighQuality)
	reflection_samples 5
      #else
	reflection_samples 1
      #end
      brilliance 8
      specular 0.8
      roughness 0.1
    }
  }
  
  #declare MGlass = material {
    texture {
      pigment { rgbf 1 }
      finish {
	diffuse 0.1
	reflection 0.2
	reflection_blur  0.01
	#if (HighQuality)
	  reflection_samples 5
	#else
	  reflection_samples 1
	#end
	reflection_type 1
	conserve_energy
	specular 0.8
	roughness 0.003
	phong 1
	phong_size 400
      } 
    }
    interior {
      ior 1.5
      fade_distance 5*cm
      fade_power 2000
      fade_color rgb <0.99, 0.98, 0.95>
    }
  }
  
  #declare TWhitePlastic = texture {
    pigment { color rgb 1.0 }
    finish {
      specular 0.5
      roughness 0.05
      brilliance 0.01
    }
    normal { bumps 0.1 scale 0.1*mm }
  }
  
  #declare TBlackPlastic = texture {
    pigment { color rgb 0.0 }
    finish {
      specular 0.5
      roughness 0.05
      brilliance 0.01
    }
    normal { bumps 0.1 scale 0.1*mm }
  }
  
  #declare TClearPlastic = texture {
    pigment { color rgbf 0.99 }
    finish {
      specular 0.5
      roughness 0.05
      brilliance 0.01
    }
    normal { bumps 0.1 scale 0.1*mm }
  }
  
#end

#include "leave"